local require=require or dofile

require "xmlrpc.lua"

-- How to write a client.  Includes some functions to exercise the
-- validator.

-- stolen code to print tables verbosely
--[[
function tostring(x)
  local s
  if type(x) == "table" then
    s = "{"
    local i, v = next(x)
    while i do
      s = s .. tostring(i) .. "=" .. tostring(v)
      i, v = next(x, i)
      if i then s = s .. "," end
    end
    return s .. "}"
  else return %tostring(x)
  end
end
]]

-- betty = XMLRPC.Server("http://betty.userland.com/RPC2")
-- res = betty.examples.getStateName(41)
-- print(res)

-- timeserv = XMLRPC.Server("http://time.xmlrpc.com/RPC2")
-- res = timeserv.currentTime.getCurrentTime()
-- print(res)

-- mirrorsrv = XMLRPC.Server("http://www.mirrorproject.com/xmlrpc/")
-- res = mirrorsrv.mirror.Random()
-- print(res)

-- Sadly, everything appears to be spelled correctly...
-- spellsrv = XMLRPC.Server("http://www.stuffeddog.com/speller/speller-rpc.cgi")
-- print(spellsrv.speller.spellCheck("how about this one? is this thing on? asdfasdf.  it asdf8 asdoi asdf.asdf asdfasdf.", {}))

-- mk = XMLRPC.Server("http://www.oreillynet.com/meerkat/xml-rpc/server.php")
-- print(mk.system.listMethods())

-- print(mk.meerkat.getItems({search='/[Pp]ython/', num_items=5, descriptions=0}))
-- print(mk.meerkat.getItems({search='/[Ll]ua/', num_items=5, descriptions=0}))

-- sf = XMLRPC.Server("http://xmlrpc-c.sourceforge.net/api/sample.php")
-- print(sf.sample.sumAndDifference(7, 15))


lh = XMLRPC.Server("http://localhost/~nop/req.cgi")
-- lh = XMLRPC.Server("http://www.place.org/~nop/lua-xml-rpc.cgi")

print(lh.localtest.towns("asdf asdfas asd asdfasfd asdf"))
print(lh.localtest.echo(XMLRPC.double(3.9)))
print(lh.localtest.echo(XMLRPC.dateTime("asdfasdfasdf")))
print(lh.localtest.echo(XMLRPC.true))
print(lh.localtest.echo({20,30,40}))
print(lh.localtest.echo({a=20,b={7,8,9}}))

randomseed(tonumber(date("%m%d%H%M%S")))

function random_stooge()
  return {moe=random(20), larry=random(20), curly=random(20)}
end

v1 = lh.validator1

print(v1.echoStructTest({moe=7, curly="hi there!", larry=12}))
print("expect 28:")
print(v1.easyStructTest({moe=7, curly=9, larry=12}))
print(v1.countTheEntities("asd9f8y(*89asdasdf<<<;&'''\"'>"))

stooges = {n=0}
for i=1,20 do
  table.insert(stooges, random_stooge())
end

print(v1.arrayOfStructsTest(stooges))

print(v1.simpleStructReturnTest(5))
